/*
 * MultiMAIL offline mail reader
 * 

   Written by Kolossvary Tamas (thomas@vma.bme.hu)

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.  */

#include "interface.h"

extern mmail			mm;
extern Interface		*interface;
extern AreaListWindow	areas;
extern LetterListWindow	letters;
extern LetterWindow     letterwindow;
extern HelpWindow		helpwindow;
extern int getstring(WINDOW *, int, int, char *, int, int, int);

tagline :: tagline(void)
{
 next = NULL;
}

TaglineWindow :: TaglineWindow(void)
{
 int i;
 int c;
 int end = 0;

 init_pair(45, COLOR_YELLOW, COLOR_YELLOW);
 init_pair(47, COLOR_WHITE, COLOR_YELLOW);
 init_pair(48, COLOR_GREEN, COLOR_YELLOW);
 list = newwin(LINES-10, COLS-2, 5, 1);
 list_max_y = LINES-14;
 wattrset(list, COLOR_PAIR(45) | A_BOLD);
 for(i=0; i < (LINES-10)*(COLS-2); i++)
	waddch(list, ' ');  
 box(list, 0, 0);
 mvwaddch(list, 0, 2, ACS_RTEE);
 mvwaddch(list, 0, 17, ACS_LTEE);
 wattrset(list, COLOR_PAIR(47) | A_BOLD);
 mvwaddstr(list, 0, 3, "Select tagline");
 mvwaddstr(list, LINES-13, 59, " - Apply tagline");
 mvwaddstr(list, LINES-13, 3,  " - Don't apply tagline");
 mvwaddstr(list, LINES-12, 3,  " - Reread tagline file");
 mvwaddstr(list, LINES-12, 28, " - Manual enter tagline");
 mvwaddstr(list, LINES-13, 28, " - Random select tagline");
 wattrset(list, COLOR_PAIR(48) | A_BOLD);
 wmove(list, LINES-14, 1);
 whline(list, ACS_HLINE, COLS-4);
 mvwaddstr(list, LINES-13, 54, "Enter");
 mvwaddch(list, LINES-13, 2,  'Q');
 mvwaddch(list, LINES-12, 2,  'F');
 mvwaddch(list, LINES-12, 27, 'E');
 mvwaddch(list, LINES-13, 27, 'R');
 
 ReadFile();
 Draw();
 
 // keyboard handling
 
 while(!end)
 {
	c=wgetch(screen);
	switch(c)
	{
	 case 'q': 	end = 1; break;
	 case 'Q': 	end = 1; break;
	 case '\033': 	end = 1; break;
	 case '\n': 	end = 1; break;
	 case 'e': 	EnterTagline(); break;
	 case 'E':	EnterTagline(); break;
	 case 'f':	ReadFile(); break;
	 case 'F':	ReadFile(); break;
	 case 'r': 	RandomTagline(); break;
	 case 'R': 	RandomTagline(); break;
	 case KEY_DOWN:	Move(DOWN); break;
	 case KEY_RIGHT:Move(DOWN); break;
	 case KEY_UP:	Move(UP); break;
	 case KEY_LEFT:	Move(UP); break;
	 case KEY_PPAGE:Move(PGUP); break;
	 case KEY_NPAGE:Move(PGDN); break;
	 case KEY_HOME: Move(HOME); break;
	 case KEY_END:  Move(END); break;
	}
  	if(!end) Draw();
 }  
 if((c == '\n') && (NumOfTaglines > 0))
	letterwindow.set_Tagline(getTextOf(active));
 DestroyChain();
 delwin(list);
 touchwin(screen);
 wnoutrefresh(screen);
 switch(interface->active())
 {
	case packetlist: break;
	case arealist: areas.ReDraw(); helpwindow.redraw(); break;
	case threadlist: break;
	case letterlist: letters.ReDraw(); helpwindow.redraw(); break;
	case letter: letterwindow.Draw(); break;
	case letter_help: break;
	case littlearealist: break;
 }
 this->~TaglineWindow();
}

void TaglineWindow :: RandomTagline(void)
{
 int i, j;

 i = rand() / (RAND_MAX / NumOfTaglines);
 Move(HOME);
 for(j=1; j <= i; j++)
	Move(DOWN);
 Draw();
}

void TaglineWindow :: EnterTagline(void)
{
 int y;
 char newtagline[TAGLINE_LENGHT + 1];
 FILE *fd;
 char filename[255];

 init_pair(17, COLOR_GREEN, COLOR_YELLOW);
 init_pair(18, COLOR_MAGENTA, COLOR_YELLOW);

 Move(END);
 if(NumOfTaglines >= list_max_y - 1)
 {
	y = list_max_y - 1;
	position++;
	active++;
 }
 else 
	{
	 y = NumOfTaglines + 1;
   	 active++;
	}
 Draw();
 newtagline[0] = '\0';
 if(getstring(list, y, 1, newtagline, TAGLINE_LENGHT, COLOR_PAIR(18) | A_BOLD, 
	      COLOR_PAIR(17) | A_BOLD));
 {
  if(newtagline[0] != '\0')
  {
  	if((fd=fopen(mm.resourceObject->get(bwTaglineFile), "a")) != NULL)
	{
  		if(ftell(fd) > 0) fputc('\n', fd);
		fputs(newtagline, fd);
	}
  	fclose(fd);
  	ReadFile();
  }
 }
 Move(END);
 Draw();
}

void TaglineWindow :: ReadFile(void)
{
 FILE *fd;
 char filename[255];
 tagline *curr;

 NumOfTaglines = 0;
 DestroyChain();
 if((fd=fopen(mm.resourceObject->get(bwTaglineFile), "r")) != NULL)
 {
  position = 0;
  active = 0;
  curr = &head;
  while(fgets(curr->text, TAGLINE_LENGHT, fd) != NULL)
  {
	if(curr->text[strlen(curr->text) - 1] == '\n')  
		curr->text[strlen(curr->text) - 1] = '\0'; //cut the \n down
  	curr->next = new tagline;
	curr = curr->next;	
	NumOfTaglines++;
  }
 }
}

void TaglineWindow :: DestroyChain(void)
{
 tagline *curr;
 tagline *tmp;

 curr = head.next;
 while(curr != NULL)
 {
	tmp = curr;
	curr = curr->next;
	delete tmp;
	 
 }
 head.next = NULL;
}

void TaglineWindow :: Draw(void)
{
 int i, j;
 
 if(NumOfTaglines > 0)
 {
  	init_pair(46, COLOR_MAGENTA, COLOR_YELLOW);
  	for(i=1; i<list_max_y; i++)
  	{
   		wattrset(list, COLOR_PAIR(46) | A_BOLD);
   		if (position+i-1 == active) wattron(list, A_REVERSE);
  		if(position+i > NumOfTaglines)
			for(j=1; j <= TAGLINE_LENGHT; j++)	
				mvwaddch(list, i, j, ' ');
		else
	 		mvwprintw(list, i, 1, "%-76s", getTextOf(position+i-1));
	}
 	wrefresh(list);
 }
 else
 {
	init_pair(46, COLOR_BLUE, COLOR_YELLOW);
	init_pair(49, COLOR_RED, COLOR_YELLOW);
  	wattrset(list, COLOR_PAIR(49));
	for(i=1; i<list_max_y; i++)
		for(j=0; j < TAGLINE_LENGHT; j++)
			mvwaddch(list, i, j+1, ' ');
	mvwaddstr(list, 3, 18, "IT SEEMS THAT YOU DON'T HAVE A TAGLINE FILE.");
	wattrset(list, COLOR_PAIR(46));
	mvwaddstr(list, 5, 8, 
		  "If you'd like to use taglines, than create a file whose name");
	mvwaddstr(list, 6, 8, 
		  "is 'taglines' in your '$HOME/mmail' directory, containing your"); 
	mvwaddstr(list, 7, 8, 
		  "favourite taglines, or use the 'E' key. You can simply choose");
	mvwaddstr(list, 8, 8, 
		  "one in this window afterwards.");
	wrefresh(list); 
 }
}

int TaglineWindow :: NumOfItems(void)
{
 return NumOfTaglines;
}

char *TaglineWindow :: getTextOf(int num)
{
 int i=1;
 tagline *curr;
 curr = &head;

 while((i <= num) && (i < NumOfTaglines))
 {
  curr = curr->next;
  i++;
 }
 return curr->text;
}
