/*
 * MultiMAIL offline mail reader
 * 

   Written by Toth Istvan (stoty@vma.bme.hu)

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.  */

#ifndef __REPLY_H
#define __REPLY_H

#include "mmail.h"
#include "internal.h"
#include "bluewave.h"

class bwreply : virtual public reply_driver
{
private:

	struct upl_list {
						UPL_REC uplRec;
						upl_list *nextRecord;
					};
	
	mmail		*mm;
	area_header *replyAreaHeader;
	int currentLetter;
	int noOfLetters;
	char *replyPacketName;
	int replyExists;
	char *replyText;
	net_address netAddr;
	
	FILE *uplFile;
	FILE *currentMsgFile;

	UPL_HEADER *uplHeader;
	
	struct upl_list *uplListHead;
	struct upl_list *uplListCurrent;
	
	int init();
	int cleanup();
	int uncompress();
	int readUpl();
	char *newFileName(const char* bwFileName);
	char *freeFileName();

public:
	bwreply(mmail *mmA);
	~bwreply();
	int getNoOfAreas();
	int resetAll();
	area_header *getNextArea();
	int selectArea(int ID);
	int getNoOfLetters();
	int resetLetters();
	letter_header *getNextLetter();
	char* getBody(int ID);
	int enterLetter(letter_header *newLetter);
	int enterNetDest(net_address netAddress);
	int killLetter(int letterNo);
	area_header *refreshArea();
	int makeReply();
};

#endif
